
% boxes.pro

/*  Ann, Bill, Charlie, Don, Eric own one box each 
    but we don't know which box. Try to find each box's' 
    owner if you know that:

    * Ann and Bill have boxes with the same colour.
    * Don and Eric have boxes with the same colour.
    * Charlie and Don have boxes with the same size.
    * Eric's box is smaller than Bill's.
*/

% ?- owners(Ann,Bill,Charlie,Don,Eric).


% Box number, color, size.
box(1, black, 3).
box(2, black, 1).
box(3, white, 1).
box(4, black, 2).
box(5, white, 3).

owners(A,B,C,D,E) :-
  permutation([1,2,3,4,5], [A,B,C,D,E]),
  box(A, ColorA, _), box(B, ColorA, _),    % Ann and Bill have same color
  box(D, ColorD, _), box(E, ColorD, _),    % Don and Eric have same color
  box(C, _, SizeC), box(D, _, SizeC),      % Charlie and Don have same size
  box(E, _, SizeE), box(B, _, SizeB),
  lt(SizeE, SizeB).                        % Eric's smaller than Bill's


permutation([], []).
permutation(L, [X|P]) :-
  del(X, L, L1),
  permutation(L1, P).

del(A, [A|List], List).
del(A, [B|List], [B|Listl]) :-
  del(A, List, Listl).


