
% errors.pro
% Andrew Davison, ad@fivedots.coe.psu.ac.th, July 2020

% Predicates with ERRORs


% Programming in Prolog, p.193
% Clocksin and Mellish

% ?- same([a,b,d], [b,a,c]).


same([],[]).
same([X|L], M) :- 
  del(X, M, N). same(L, N).

del(X, [X|L], L).
del(X, [Y|L1], [Y|L2]) :- 
  del(X, L1, L2).



% -------------------------------

% ?- between(2,0,3).
% ?- between(5,0,3).

% binds Num to values between Min and Max  
between(Min, Min, Max) :-
  le(Min, Max).
between(Num, Min, Max) :-
  % le(Min, Max),
  is(Min1, add(Min,1)),
  between(Num, Min1, Max).



% -----------------------------------
% https://www.informit.com/articles/article.aspx?p=691500&seqNum=4

% ?- isEven(5).

isEven(2).
isEven(X) :- 
  is(Y, sub(X,2)), 
  isEven(Y).


% -------------------------------
% https://www.metalevel.at/prolog/debugging

% ?- listLength([1,2], 2).
    

listLength([], 0).
listLength([_|Ls], N) :-
  listLength(Ls, N0),
  is(N, add(N0,2)).

