
% hanoi.pro
% Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

% Towers of Hanoi

%	hanoi(N,A,B,C,Moves) :-
%		Moves is the sequence of moves required to move N discs
%		from peg A to peg B using peg C as an intermediary
%		according to the rules of the Towers of Hanoi puzzle

%  ?- hanoi(3,l,r,c,Res).




hanoi(1,A,B,C,[fromto(A,B)]).
hanoi(N,A,B,C,Moves) :-
  gt(N,1),
  is(N1, sub(N, 1)),
  hanoi(N1,A,C,B,Ms1),
  hanoi(N1,C,B,A,Ms2),
  append(Ms1,[fromto(A,B)|Ms2],Moves).


append([],L,L).
append([H|T],L2,[H|L3]) :- append(T,L2,L3). 
