
// lanford.pro

/* "Prolog by Example" by Helder Coelho Jose C. Cotta,
    problem 102

  Arrange 3 1’3, 3 2’s, . . ., 3 9’s in sequence so that for 
  all i there are exactly i numbers between successive i’s.

  This is a version of the Lanford sequence, when n == 9
  but for triples
  https://en.wikipedia.org/wiki/Langford_pairing

  Found three answers before max op count was reached.

*/

% ?- arrange(S).

arrange(S):-
  sequence(S),
  in([1,_,1,_,1],S),
  in([2,_,_,2,_,_,2],S),
  in([3,_,_,_,3,_,_,_,3],S),
  in([4,_,_,_,_,4,_,_,_,_,4],S),
  in([5,_,_,_,_,_,5,_,_,_,_,_,5],S),
  in([6,_,_,_,_,_,_,6,_,_,_,_,_,_,6],S),
  in([7,_,_,_,_,_,_,_,7,_,_,_,_,_,_,_,7],S),
  in([8,_,_,_,_,_,_,_,_,8,_,_,_,_,_,_,_,_,8],S),
  in([9,_,_,_,_,_,_,_,_,_,9,_,_,_,_,_,_,_,_,_,9],S).

sequence(
  [_,_,_,_,_,_,_,_,_,
   _,_,_,_,_,_,_,_,_,
   _,_,_,_,_,_,_,_,_]).


in(Y, XYZ) :- 
  append(X,YZ,XYZ), append(Y,Z,YZ).


append([],Y,Y).
append([A|X],Y,[A|Z]) :- 
  append(X,Y,Z).
