
% lists.pro
% Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

% list predicates

rev(List, Rev) :-
          rev3(List, [], Rev).

rev3([], Rev, Rev).
rev3([Head|Tail], SoFar, Rev) :-
          rev3(Tail, [Head|SoFar], Rev).

append([],L,L).
append([H|T],L2,[H|L3]) :- append(T,L2,L3). 

prefix(P,L):-  append(P,_,L). 

naiverev([],[]).
naiverev([H|T],R) :-  naiverev(T,RevT), append(RevT,[H],R). 

member(X, [X|_]).
member(X, [Y|Rest]) :- member(X, Rest).


perm([], []).
perm(L, [X|P]) :-
  del(X, L, L1),
  perm(L1, P).

del(A, [A|List], List).
del(A, [B|List], [B|Listl]) :-
  del(A, List, Listl).

length([], 0).
length([_|Rest], N) :-
  length(Rest, N1),
  is(N, add(N1, 1)).
