
% maze.pro
% A program that finds a path through a maze.

/* Inspired by "PROLOG PROGRAMMING IN DEPTH"
  by Michael A. Covington, Donald Nute, and Andre Vellino
  Prentice Hall, 1997
*/

% ?- maze(Path).


maze([Loc|Path]) :-
  start(Loc), 
  path(Loc, [Loc], Path).


path(Loc, _, []):-
  finish(Loc).
path(Loc,Vis, [Loc1|Path]) :-
  step(Loc,Loc1),
  unvisited(Loc1,Vis),
  path(Loc1,[Loc1|Vis], Path).

step(Loc1,Loc2) :- 
  connect(Loc1,Loc2).
step(Loc1,Loc2) :- 
  connect(Loc2,Loc1).

unvisited(X,[]).
unvisited(X,[Y|Rest]) :-
  nunify(X,Y),
	unvisited(X,Rest).

% see maze.png

start(2).
finish(32).

connect(1,7).            connect(2,3).
connect(2,8).            connect(3,4).
connect(3,9).            connect(4,10).
connect(5,11).           connect(5,6).
connect(7,13).           connect(8,9).
connect(10,16).          connect(11,17).
connect(12,18).          connect(13,14).
connect(14,15).          connect(14,20).
connect(15,21).          connect(16,22).
connect(17,23).          connect(18,24).
connect(19,25).          connect(20,26).
connect(21,22).          connect(23,29).
connect(24,30).          connect(25,31).
connect(26,27).          connect(27,28).
connect(28,29).          connect(28,34).
connect(30,36).          connect(31,32).
connect(32,33).          connect(33,34).
connect(34,35).          connect(35,36).

