
% sorts.pro
% Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

% quicksort and insertion sort

% ?- isort([4, 1, 2, 7, 3, 2], S).
% ?- qsort([4, 1, 2, 7, 3, 2], S).


qsort([X|Xs],Ys) :-
  partition(Xs,X,Littles,Bigs),
  qsort(Littles,Ls),
  qsort(Bigs,Bs),
  append(Ls,[X|Bs],Ys).
qsort([],[]).


partition([X|Xs],Y,[X|Ls],Bs) :- le(X,Y), partition(Xs,Y,Ls,Bs).
partition([X|Xs],Y,Ls,[X|Bs]) :- gt(X,Y), partition(Xs,Y,Ls,Bs).
partition([],Y,[],[]).


append([],Ys,Ys).
append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).


% --------------------------------

isort([X|Xs],Ys) :- isort(Xs,Zs), insert(X,Zs,Ys).
isort([],[]).

insert(X,[],[X]).
insert(X,[Y|Ys],[Y|Zs]) :- gt(X,Y), insert(X,Ys,Zs).
insert(X,[Y|Ys],[X,Y|Ys]) :- le(X,Y).
