
% sudoku2.pro
% Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

% quicksort and insertion sort

% ?- sudoku.

/*   [4, 2, 6,  5, 7, 1,  3, 9, 8]
     [8, 5, 7,  2, 9, 3,  1, 4, 6]
     [1, 3, 9,  4, 6, 8,  2, 7, 5]
                          
     [9, 7, 1,  3, 8, 5,  6, 2, 4]
     [5, 4, 3,  7, 2, 6,  8, 1, 9]
     [6, 8, 2,  1, 4, 9,  7, 5, 3]
                          
     [7, 9, 4,  6, 3, 2,  5, 8, 1]
     [2, 6, 5,  8, 1, 4,  9, 3, 7]
     [3, 1, 8,  9, 5, 7,  4, 6, 2]

  Hiding 12 integers is the limit., and then only with
  max op count removed from BuWAM.java (line 300-ish)

  Illustrates the need for constraints
*/



sudoku :-
  % define the square
  unify(S,
   [ [V11, V12, V13, V14, V15, V16, V17, V18, V19],
     [V21, V22, V23, V24, V25, V26, V27, V28, V29],
     [V31, V32, V33, V34, V35, V36, V37, V38, V39],
     [V41, V42, V43, V44, V45, V46, V47, V48, V49],
     [V51, V52, V53, V54, V55, V56, V57, V58, V59],
     [V61, V62, V63, V64, V65, V66, V67, V68, V69],
     [V71, V72, V73, V74, V75, V76, V77, V78, V79],
     [V81, V82, V83, V84, V85, V86, V87, V88, V89],
     [V91, V92, V93, V94, V95, V96, V97, V98, V99]
   ]),
   %
   % specify bindings by row
      u(V11,4), u(V12,2), u(V13,6),     % row 1
/*     u(V14,5), u(V15,7), u(V16,1), */
      u(V17,3), u(V18,9), u(V19,8),

      u(V21,8), u(V22,5), u(V23,7),     % row 2 
      u(V24,2), u(V25,9), u(V26,3), 
      u(V27,1), u(V28,4), u(V29,6),

      u(V31,1), u(V32,3), u(V33,9),     % row 3 
/*      u(V34,4), u(V35,6), u(V36,8),  */
      u(V37,2), u(V38,7), u(V39,5),

      u(V41,9), u(V42,7), u(V43,1),     % row 4 
      u(V44,3), u(V45,8), u(V46,5), 
      u(V47,6), u(V48,2), u(V49,4),

      u(V51,5), u(V52,4), u(V53,3),     % row 5
      u(V54,7), u(V55,2), u(V56,6), 
      u(V57,8), u(V58,1), u(V59,9),

      u(V61,6), u(V62,8), u(V63,2),     % row 6 
      u(V64,1), u(V65,4), u(V66,9), 
      u(V67,7), u(V68,5), u(V69,3),

/*      u(V71,7), u(V72,9), u(V73,4),  */   % row 7 
      u(V74,6), u(V75,3), u(V76,2), 
      u(V77,5), u(V78,8), u(V79,1),

      u(V81,2), u(V82,6), u(V83,5),     % row 8 
      u(V84,8), u(V85,1), u(V86,4), 
      u(V87,9), u(V88,3), u(V89,7),

      u(V91,3), u(V92,1), u(V93,8),     % row 9 
      u(V94,9), u(V95,5), u(V96,7), 
      u(V97,4), u(V98,6), u(V99,2),
   %
   writeln('Start: '),
   writeSquare(S),
   % other numbers are in the range 1-9
   u(Ns, [1,2,3,4,5,6,7,8,9]),
   %
   % all groups unique
   uniq([V11, V12, V13,  V21, V22, V23,  V31, V32, V33], Ns),
   uniq([V14, V15, V16,  V24, V25, V26,  V34, V35, V36], Ns),
   uniq([V17, V18, V19,  V27, V28, V29,  V37, V38, V39], Ns),
                                                      
   uniq([V41, V42, V43,  V51, V52, V53,  V61, V62, V63], Ns),
   uniq([V44, V45, V46,  V54, V55, V56,  V64, V65, V66], Ns),
   uniq([V47, V48, V49,  V57, V58, V59,  V67, V68, V69], Ns),
                                                      
   uniq([V71, V72, V73,  V81, V82, V83,  V91, V92, V93], Ns),
   uniq([V74, V75, V76,  V84, V85, V86,  V94, V95, V96], Ns),
   uniq([V77, V78, V79,  V87, V88, V89,  V97, V98, V99], Ns),

   % all rows unique
   uniq([V11, V12, V13, V14, V15, V16, V17, V18, V19], Ns),
   uniq([V21, V22, V23, V24, V25, V26, V27, V28, V29], Ns),
   uniq([V31, V32, V33, V34, V35, V36, V37, V38, V39], Ns),
   uniq([V41, V42, V43, V44, V45, V46, V47, V48, V49], Ns),
   uniq([V51, V52, V53, V54, V55, V56, V57, V58, V59], Ns),
   uniq([V61, V62, V63, V64, V65, V66, V67, V68, V69], Ns),
   uniq([V71, V72, V73, V74, V75, V76, V77, V78, V79], Ns),
   uniq([V81, V82, V83, V84, V85, V86, V87, V88, V89], Ns),
   uniq([V91, V92, V93, V94, V95, V96, V97, V98, V99], Ns),
   %
   % all cols unique
   uniq([ V11, V21, V31, V41, V51, V61, V71, V81, V91], Ns),
   uniq([ V12, V22, V32, V42, V52, V62, V72, V82, V92], Ns),
   uniq([ V13, V23, V33, V43, V53, V63, V73, V83, V93], Ns),
   uniq([ V14, V24, V34, V44, V54, V64, V74, V84, V94], Ns),
   uniq([ V15, V25, V35, V45, V55, V65, V75, V85, V95], Ns),
   uniq([ V16, V26, V36, V46, V56, V66, V76, V86, V96], Ns),
   uniq([ V17, V27, V37, V47, V57, V67, V77, V87, V97], Ns),
   uniq([ V18, V28, V38, V48, V58, V68, V78, V88, V98], Ns),
   uniq([ V19, V29, V39, V49, V59, V69, V79, V89, V99], Ns),
   %
   writeln('End: '),
   writeSquare(S).

u(X,Y) :- unify(X,Y).
 

uniq(Vars, Nums) :-
  removeVals(Vars, Nums, Vars1, Nums1), !,
  diff(Vars1, Nums1).


% remove integer values in Vars from Nums
removeVals([], Nums, [], Nums).
removeVals([X|Vars], Nums, Vars1, Nums2) :-
  nonvar(X),
  extract(X, Nums, Nums1), !,
  removeVals(Vars, Nums1, Vars1, Nums2).
removeVals([X|Vars], Nums, [X|Vars1], Nums1) :-
  removeVals(Vars, Nums, Vars1, Nums1).


diff([], []).
diff([El|Rest], Ns) :-
  extract(El, Ns, Ns1),
  diff(Rest, Ns1).


extract(X, [X|Rest], Rest).
extract(X, [Y|Rest], [Y|Ns]) :-
  extract(X, Rest, Ns).


writeSquare([]):- 
  writeln(''), writeln('').
writeSquare([Line|Rest]):-
  writeln(Line),
  writeSquare(Rest).

