
% A Tic-Tac-Toe program in Prolog.   
% Based on code by S. Tanimoto, 2003.
%  https://courses.cs.washington.edu/courses/cse341/03sp/slides/PrologEx/tictactoe.pl.txt
% ?- xStarts. 



xStarts :- 
  writeln('Enter an integer pos followed by a period.'),
  showBoard([1,2,3,4,5,6,7,8,9]),
  play(['.','.','.',
        '.','.','.',
        '.','.','.' ]).


showBoard([A,B,C,D,E,F,G,H,I]) :- 
  write('  '), write(A), write(' '), write(B), write(' '), writeln(C),
  write('  '), write(D), write(' '), write(E), write(' '), writeln(F),
  write('  '), write(G), write(' '), write(H), write(' '), writeln(I),
  writeln('').



play(Bd) :- 
  win(Bd, x), !,
  writeln('You win!').
play(Bd) :- 
  win(Bd, o), !,
  writeln('I win!').
play(Bd) :-
  writeln('Your move:'), 
  readln(N),
  move(Bd, N, x, NBd1), 
  showBoard(NBd1),
  writeln('My move:'),
  compMove(NBd1, NBd2), 
  showBoard(NBd2), !,
  play(NBd2).





% the winning conditions:

win(Bd, P) :-      % 3 rows
  unify(Bd, [P,P,P,
             _,_,_,
             _,_,_]).

win(Bd, P) :- 
  unify(Bd, [_,_,_,
             P,P,P,
             _,_,_]).

win(Bd, P) :- 
  unify(Bd, [_,_,_,
             _,_,_,
             P,P,P]).

win(Bd, P) :-     % 3 columns
  unify(Bd, [P,_,_,
             P,_,_,
             P,_,_]).

win(Bd, P) :- 
  unify(Bd, [_,P,_,
             _,P,_,
             _,P,_]).

win(Bd, P) :- 
  unify(Bd, [_,_,P,
             _,_,P,
             _,_,P]).

win(Bd, P) :-     % 2 diagonals
  unify(Bd, [P,_,_,
             _,P,_,
             _,_,P]).

win(Bd, P) :- 
  unify(Bd, [_,_,P,
             _,P,_,
             P,_,_]).



% translate from an integer
% of x's move to a board position.

move(['.',B,C,D,E,F,G,H,I], 1, P, [P,B,C,D,E,F,G,H,I]).
move([A,'.',C,D,E,F,G,H,I], 2, P, [A,P,C,D,E,F,G,H,I]).
move([A,B,'.',D,E,F,G,H,I], 3, P, [A,B,P,D,E,F,G,H,I]).
move([A,B,C,'.',E,F,G,H,I], 4, P, [A,B,C,P,E,F,G,H,I]).
move([A,B,C,D,'.',F,G,H,I], 5, P, [A,B,C,D,P,F,G,H,I]).
move([A,B,C,D,E,'.',G,H,I], 6, P, [A,B,C,D,E,P,G,H,I]).
move([A,B,C,D,E,F,'.',H,I], 7, P, [A,B,C,D,E,F,P,H,I]).
move([A,B,C,D,E,F,G,'.',I], 8, P, [A,B,C,D,E,F,G,P,I]).
move([A,B,C,D,E,F,G,H,'.'], 9, P, [A,B,C,D,E,F,G,H,P]).




% generate the computer's (player o) reponse

compMove(Bd, NBd) :- 
  member(Pos, [1,2,3,4,5,6,7,8,9]),
  move(Bd, Pos, o, NBd),
  win(NBd, o).
compMove(Bd, NBd) :- 
  member(Pos, [1,2,3,4,5,6,7,8,9]),
  move(Bd, Pos, o, NBd), 
  not( xWins(NBd) ).
compMove(Bd, NBd) :-
  member(Pos, [1,2,3,4,5,6,7,8,9]),
  move(Bd, Pos, o, NBd).
compMove(Bd, NBd) :-
  not( member('.',Bd) ),
  writeln('Deadlock!'),
  unify(Bd, NBd).



xWins(Bd) :- 
  member(Pos, [1,2,3,4,5,6,7,8,9]),
  move(Bd, Pos, x, NBd), 
  win(NBd, x).




member(X, [X|_]).
member(X, [Y|Rest]) :- member(X, Rest).


not(X) :- call(X), !, fail.
not(X).

