
// Env.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

/* An environment consists of the PERM vars occurring in 
   the body of the current clause,  
   a continuation pointer (return address), and other data

   Environments are stored in a list, not a stack, since 
   returning from a
   clause does not cause the environment to be 'popped'
   since it may be needed again during backtracking
*/

import java.util.*;


public class Env
{
  // public so the data can be accessed without get() methods;
  // think of it as a record

  public ArrayList<Var> vars;       // permanent vars used in this clause

  public int ce;  // continuation environment index 
                   // (what env to return to)

  public int cp;  // contination pointer (return address)


  // debugging data
  public String clauseLabel;
  public String tryNodeNm;   // labels used in call graph
  public int tryCount;



  public Env(String clauseLabel, int addr, int envIdx,
                    String tryNodeNm,int tryCount)
  {
    this.clauseLabel = clauseLabel;
    this.tryNodeNm = tryNodeNm;
    this.tryCount = tryCount;

    vars = new ArrayList<>();   // PERM vars
    cp = addr; 
    ce = envIdx;
  } // end of Env()




} // end of class Env


