
// LexerTest.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

/* Test rig for the lexer generated from Lexer.jflex.  
   Usage:
       java LexerTest hanoi.pro
*/

import java.io.*;


public class LexerTest
{
  public static void main(String[] args)
  {
    if (args.length != 1) {
      System.out.println("Usage: java LexerTest <fnm>");
      return;
    }
      
    Token tok;
    try {
      Lexer lexer = new Lexer(new FileReader(args[0]), true);
                            // printing is on
      tok = lexer.nextToken();
      while (tok.symbol() != Toks.EOF) {
        // System.out.print(tok + " ");
        // no need to print if Lexer() called with true arg
        tok = lexer.nextToken();
      }
      System.out.println();
    }
    catch (Exception e) 
    { System.out.println(e.getMessage()); }
  }

}  // end of LexerTest class
