
// ParseType.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

/* ParseNode types.
*/

public enum ParseType
{
  NO_TYPE("noType"),
  
  QUERY("query"),
  TERM("term"),
  ARGS("args"), 
  CONSTANT("con"),
  VARIABLE("var"),
  ATOM("atom"),
  STR("str"),
  CLAUSE("clause"),
  CLAUSES("cls"),
  PREDICATE("pred"),
  BODY("body"),
  CALL("call"),

  LIST("list"), 
  LIST_ARGS("largs"),
  STRUCTURE("struct");


  private String text;


  ParseType(String text) 
  {  this.text = text; }


  public String getText() 
  {  return this.text; }


  public static ParseType fromString(String text) 
  {
    for (ParseType b : ParseType.values()) {
      if (b.text.equalsIgnoreCase(text))
        return b;
    }
    return NO_TYPE;
  }  // end of fromString()


}  // end of ParseType class
