
// Token.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

/* The Lexer code returns a series of Token objects
   representing the lexical units in the language. 

   Used by Lexer.jflex.
   The tokens are read by BuProlog to generate 
   a syntax tree.
*/

public class Token
{
  private Toks symbol;      // current token
  private String lexeme = null;   // token value as a string


  public Token(Toks sym)
  {  symbol = sym;  }


  public Token(Toks sym, String val)
  { symbol = sym;
    lexeme = val;
  }

  public Toks symbol()
  {  return symbol;  }


  public String lexeme()
  {  return lexeme; }


  public String toString()
  {
    if ((symbol == Toks.ATOM) || (symbol == Toks.VAR) ||
        (symbol == Toks.STR) || (symbol == Toks.INTEGER))
      return "(" + symbol.getText() +": " + lexeme + ") ";
    else
      return symbol.getText();
  }  // end of toString()

}  // end of Token class
