
// Toks.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, June 2020

/* used to distinguish between Token objects.
   Used by Lexer.jflex.
*/

public enum Toks
{
  EOF("eof"), 

  // punctuation
  LPAREN("("), 
  RPAREN(")"), 
  PERIOD("."), 
  COMMA(","), 
  IF(":-"), 
  QUERY("?-"), 

  // lists
  LSQUARE("["), 
  RSQUARE("]"), 
  BAR("|"),

  // extras
  CUT("!"), 
 
  // data types
  ATOM("atom"), 
  STR("str"),
  VAR("var"),
  INTEGER("integer");




  private String text;


  Toks(String text) 
  {  this.text = text; }


  public String getText() 
  {  return this.text; }


  public static Toks fromString(String text) 
  {
    for (Toks b : Toks.values()) {
      if (b.text.equalsIgnoreCase(text))
        return b;
    }
    return EOF;
  }  // end of fromString()


}  // end of Toks class
