
@echo off

setlocal

echo.
echo Deleting any old class files...
del *.class

if not %errorlevel% == 0 (
  echo Deletion error
  exit /B 1
)


echo.
call jflex.bat

if not %errorlevel% == 0 (
  echo Flex error
  exit /B 1
)

echo.
echo Compiling Java files...
javac *.java

if not %errorlevel% == 0 (
  echo Compilation error
  exit /B 1
)

echo.
echo Making BuProlog.jar...
jar -cfm BuProlog.jar  CompilerManifest.txt ^
  BuProlog.class ^
  CallGraph.class ^
  Lexer.class ^
  Token.class ^
  Toks.class ^
  ParseNode.class ^
  ParseType.class ^
  WAMProgram.class ^
  WAMClause.class ^
  Builtin.class ^
  OpWam.class ^
  WAMStatement.class

if not %errorlevel% == 0 (
  echo JARing error
  exit /B 1
)

echo.
echo Making BuWAM.jar...
jar -cfm BuWAM.jar WAMManifest.txt ^
  BuWAM.class ^
  BuWAM$1.class ^
  CallGraph.class ^
  WAMCode.class ^
  Builtin.class ^
  OpWam.class ^
  WAMClause.class ^
  WAMStatement.class ^
  BuProlog.class ^
  Lexer.class ^
  Token.class ^
  Toks.class ^
  ParseNode.class ^
  ParseType.class ^
  ChoicePoint.class ^
  Trail.class ^
  Env.class ^
  Var.class ^
  Var$ValType.class ^
  VarType.class

if not %errorlevel% == 0 (
  echo JARing error
  exit /B 1
)

echo.
echo Copying BuProlog.jar to examps\
copy BuProlog.jar ..\examps

echo.
echo Copying BuWAM.jar to examps\
copy BuWAM.jar ..\examps

